import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


/** Servlet Eingabe eines einzelnen Artikels
  * @author Bernhard Fiser 0109815
  */
public class ArtikelDetailServlet extends HttpServlet
{
	private static ArtikelVerwaltung
			av;
	private Artikel	a;


	/** Servletinitialisierung. Hier wird die Artikeldatei von der Festplatte durch
	  * aufrufen der Methode 'load' gelesen. */
	public void init()
	{
		this.load();
	}

	/** Artikeldatei lesen. Hier wird die Artikeldatei von der Festplatte
	  * gelesen, bzw. eine neue Liste erstellt, falls das Objekt noch nicht existiert. */
	public void load()
	{
		try
		{
		        ObjectInputStream objectInput = new ObjectInputStream(new FileInputStream("/home/itpt/a0109815/public_html/servlets/store/artikel.dat"));
			av = (ArtikelVerwaltung) objectInput.readObject();
			objectInput.close();
		}

		catch (Exception e)
		{
			av = new ArtikelVerwaltung();
		}
	}

	/** CGI-POST Methode, wird auf die CGI-GET Methode weitergeleitet */
	public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
	{
		this.doGet(request, response);
	}

	/** CGI-GET Methode, hier findet gesamte Verarbeitung statt */
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
	{
		int	id;

		/* Contenttype der HTML-Seite setzen */
		response.setContentType("text/html");
		/* outputhandle erstellen */
		PrintWriter out = response.getWriter();
		/* HTML Seite beginnen */
		out.println(
			"<html><head><meta name=\"author\" content=\"Bernhard Fiser\">" +
			"<meta name=\"date\" content=\"2002-05-14T08:29:00+56:00\">" +
			"<title>Artikelverwaltung:Artikeldetails - Bernhard Fiser 0109815</title></head>" +
			"<body bgcolor=\"#ffffff\">\n<form method=\"post\" action=\"ArtikelVerwaltungServlet\">");

		/* CGI-Parameter 'cgi_id' aus FORM bernehmen... */
		String sid = request.getParameter("cgi_id");
		id = 0;
		/* ... und falls dieser vorhanden .. */
		if (sid != null && sid.length() != 0)
		{
			/* ... in int konvertieren ... */
			try { id = Integer.parseInt(sid); }
			/* ... und auf 0 setzen, falls Mll bergeben wurde. */
			catch (NumberFormatException e) { id = 0; }
			if (id < 0)
				id = 0;
		}

		/* Artikel aus Datei lesen */
		this.load();
		/* neue Artikel erzeugen, falls keine sinnvolle ID vorhanden ist */
		if (id == 0)
			a = new Artikel(0, "", 0, 0, "");
		else
			/* falls doch, Artikel aus Hashmap lesen ... */
			if ((a = av.getArtikel(id)) == null)
				/* ... oder neuen, leeren Artikel anlegen, falls kein Artikel existiert */
				a = new Artikel(0, "", 0, 0, "");

		/* Tabelle mit Inputfelder erstellen, und defaultwerte Eintragen */
		out.println("<table border=\"0\">");
		out.println("<tr><td>ID:</td><td><input type=\"text\" name=\"cgi_id\" value=\"" + a.getID() + "\"></td>");
		out.println("<tr><td>Bezeichnung:</td><td><input type=\"text\" name=\"cgi_desc\" value=\"" + a.getDescription() + "\"></td>");
		out.println("<tr><td>Preis:</td><td><input type=\"text\" name=\"cgi_preis\" value=\"" + (double) a.getPreis() / 100 + "\"></td>");
		out.println("<tr><td>Menge:</td><td><input type=\"text\" name=\"cgi_menge\" value=\"" + a.getMenge() + "\"></td>");
		out.println("<tr><td>URL:</td><td><input type=\"text\" name=\"cgi_url\" value=\"" + a.getURL() + "\"></td>");
		out.println("</table><hr><input type=\"submit\" name=\"cgi_save\" value=\"Speichern\">");
		out.println("<input type=\"submit\" name=\"cgi_list\" value=\"Zur&uuml;ck\">");
		out.println("</body></html>\n");
	}
}
